* [English version](../../README.md)

[![paypal](https://www.paypalobjects.com/fr_FR/i/btn/btn_donateCC_LG.gif)](https://www.paypal.com/cgi-bin/webscr?cmd=_donations&business=7WPD78QUVJ9D4&lc=FR&item_name=DJ%20Ca%c3%absar%209114&item_number=customfields%2dprojects%2dredmine&currency_code=EUR&bn=PP%2dDonationsBF%3abtn_donateCC_LG%2egif%3aNonHosted)
___

# Besoin

Lorsqu'une institution gère un grand nombre de projets, il peut être intéressant pour des personnes ayant un rôle transverse (DSI, Correspondant Informatique et Libertés, DAF, etc.) de disposer d'une vue globale à tout moment, sans avoir à solliciter l'ensemble des chefs de projets.
Prenons l'exemple d'un CIL: il souhaite connaître le numéro de déclaration CNIL d'un projet, sa date de déclaration, le type de données qu'il contient, etc. Il n'a pas besoin de connaître le détail de chaque projet, et il pourrait s'avérer fastidieux de devoir attendre la réponse de chaque chef de projet dans sa boîte courriel lorsqu'une question est posée, alors que tout peut être inscrit dans un outil collaboratif.
C'est ce besoin qui est comblé ici.

# À qui est-ce destiné?

Cette application est destinée à des personnes ayant une responsabilité transverse sur des projets. Si ces projets sont déjà gérés avec Redmine, cela ne changera en rien l'habitude des chefs de projet.

# Ce qu'il faut

* NodeJS
* Redmine

*__note:__ je n'ai pas testé toutes les versions, mais je sais qu'avec NodeJS 8+ et Redmine 3.3.0+ l'application fonctionne parfaitement. Merci de m'indiquer les versions que vous utilisez et si l'application fonctionne ou non.*

# Comment ça marche?

Le principe de l'application est de déceler dans Redmine quels projets sont éligibles, sur la base d'un champ particulier, et d'afficher les statistiques et informations des projets de manière synthétique.

## Les fonctionnalités

### L'en-tête

L'en-tête comprend le titre (paramétrable), des icônes correspondant aux fonctionnalités et des logos (paramétrables).

> ![Icônes du menu][menu]

### La page d'accueil ![l'icône de l'accueil][icone_accueil]

C'est une page basique qui explique toutes les fonctionnalités.

### Le récapitulatif des projets ![l'icône du récapitulatif des projets][icone_recapitulatif]

Il s'agit d'un tableau qui récapitule la complétion des champs et le contenu de ceux-ci. Il est possible d'exporter le tableau, de sélectionner les colonnes à afficher et de rechercher dans tout le tableau. En cliquant sur le nom d'un projet on accède à sa page.

> ![Récapitulatif des projets][recapitulatif_projets]

### Les statistiques des projets ![l'icône des statistiques][icone_statistiques]

Cette page permet d'avoir un aperçu global du remplissage des champs:

> ![Statistiques des projets][statistiques_projets]

Quand on clique sur une statistique (barre verte de champ rempli ou rouge de champ non rempli), s'affiche la liste des projets concernés:

> ![Liste des projets concernés par la statistique][statistiques_projets_resultats]

Il est alors possible de cliquer sur un projet pour accéder à sa page.

### Les pages wiki des projets ![l'icône du wiki des projets][icone_wiki]

Cet icône n'est pas affiché s'il n'y a aucune page wiki de configurée.
Il faut sélectionner un projet et une page.

> ![Pages wiki d'un projet][wiki_projet]

Si une page n'existe pas, un message d'erreur est affiché indiquant que la page n'est pas remplie:

> ![Pages wiki d'un projet manquante][wiki_projet_manquant]

### La vision d'un projet ![l'icône des pages des projets][icone_pageProjet]

Sont disponibles sur cette page toutes les informations dans les champs remplis d'un projet. Il est possible d'aller sur le Redmine du projet en cliquant sur son nom, et d'imprimer les informations en cliquant sur l'imprimante.

> ![Résumé d'un projet][resume_projet]

### La création d'un projet ![l'icône de création de projet][icone_creerProjet]

Il s'agit d'un formulaire généré automatiquement à partir des champs sélectionnés dans la configuration:

> ![Formulaire de création de projet][creer_projet]

Il se remplit normalement, chaque champ pouvant s'effacer avec la petite croix noire à côté; il est possible de réinitialiser tous les champs en cliquant sur le bouton rouge.

> ![Formulaire de création de projet rempli][creer_projet_rempli]

Si le projet a bien été créé, vous aurez le message suivant:

> ![Création de projet effectuée][creer_projet_succes]

## Configuration de Redmine

Il faut ajouter dans Redmine un champ personnalisé de type booléen qui sera associé à chaque projet. Dès qu'un projet aura comme valeur "vrai" dans ce champ, il sera affiché dans l'application:

> ![Créer un champ éligible dans Redmine][champ_eligible_redmine]

Il faut bien que ce champ soit utilisé comme filtre. Par défaut, je conseille de le mettre à "non", et de ne pas le rendre obligatoire, certains projets pouvant ne rien avoir à en faire.

Vous pouvez ensuite créer tout un tas de champs particuliers qui serviront dans l'application.

Pour l'ensemble des champs, il faut noter leur identifiant (un numéro), car ce sont ces numéros qu'il faudra entrer dans la configuration de l'application.

## Configuration de l'application

### Installation

#### en utilisant NPM

...bientôt...

#### à partir de la source Github

```sh
$ git clone https://github.com/djcaesar9114/customfields-projects-redmine
$ cd customfields-projects-redmine
$ npm install
```

### Configuration

Il y a deux éléments à configurer dans l'application:
* la clé utilisée pour contacter l'API Redmine;
* les fichiers de configuration `default.json` et `production.json`, présents dans le dossier `/config`.

À chaque fois que vous changez la configuration, il faut relancer l'application.

#### La clé API Redmine

L'application a besoin d'une clé API Redmine correspondant à un utilisateur ayant les droits de visibilité sur les projets et les champs voulus. Ce que je conseille est de créer un utilisateur particulier, comme "customfields-projects-redmine", et d'utiliser sa clé.
Une fois que vous avez la clé, il suffit de créer un fichier `redmineAPIKey.key` là où est installée l'application (i.e. dans le même répertoire que `index.js`), et d'indiquer la clé de cette manière:

```javascript
var key = '9114934c4ce0bc97363ff3086983d576db08d115';
exports.key = key;
```

**Pourquoi ne pas mettre cette clé dans les paramètres?**
*J'ai pour habitude de ne jamais partager aucune des informations permettant d'accéder à des informations personnelles. Mettre une telle clé dans un fichier séparé m'assure de ne jamais la divulguer par inadvertance si jamais je publie une version de l'application dans laquelle j'aurais laissé une clé dans un fichier de configuration.*

#### Fichiers de configuration

Il y a au moins un fichier de configuration à remplir: `default.json`. Si jamais en production vous avez des valeurs différentes, il faut remplir `production.json`. Toutes les variables trouvées dans `production.json` seront prioritaires par rapport à celles de `default.json`

```JSON
{
  "Application":{
    // port auquel sera accessible l'application
    "port": 9114
  },
  "IHM": {
    // titre de l'application
    "titre": "Récapitulatif CNIL des projets",
    // [FACULTATIF] liste des images à mettre dans l'en-tête, avec la taille et le lien
    "images": [
      {
        "name": "cnil_logo-large.png",
        "title": "CNIL",
        "height": "20px",
        "link": "http://cnil.fr"
      },
      {
        "name": "djcaesar9114_logo_officiel_transparent.png",
        "title": "DJ Caësar 9114",
        "height": "20px",
        "link": "http://djcaesar9114.com"
      }
    ]
  },
  "Redmine": {
    // URL du Redmine
    "url": "https://monredmine.url",
    // [FACULTATIF] nombre maximum de projets traités, par défaut 100 si non précisé
    "maxProjets": 200,
    // id du champ personnalisé qui correspond à l'éligibilité
    "champEligible": 18,
    // ids des champs qui nous intéressent. Il ne faut pas mettre ID_CHAMP_ELIGIBLE!
    "champRetenus": [16, 17, 19, 20, 21, 22, 23],
    // id des projets dont on ne veut pas qu'ils apparaissent sur la liste
    "projetsCendures": [20, 21],
    // [FACULTATIF] liste des pages wiki acceptées par l'application
    "pagesWiki": [
      {
        titre: 'Informations traitées',
        url: 'Partie_1'
      },
      {
        titre: 'Mentions légales',
        url: 'Partie_2'
      }
    ]
  }
}
```

### Lancement de l'application

Si vous n'avez pas de différence entre la configuration par défaut et la production (i.e. vous n'avez pas de fichier `production.json`), vous pouvez directement lancer:

```sh
$ node index.js
```

En revanche, si vous avez des paramètres particuliers en production, il y a une légère nuance:

```sh
$ export NODE_ENV=production
$ node index.js
```

Si vous voulez conserver les fichiers de log, vous pouvez naturellement faire ceci:

```sh
$ node index.js >> /var/log/customfields-projects-redmine.log
```

### Journaux

L'application est très verbeuse:
* **[PROJET]:** décrit l'action effectuée sur un projet:
  * *éligible:* le projet est bien éligible, il est pris;
  * *non éligible:* le projet n'est pas éligible, on ne le prend pas;
  * *sauté:* le projet n'est pas traité, on ne regarde pas son éligibilité;
  * si aucun projet n'est éligible, un message particulier apparaît;
* **[ERREUR REDMINE]:** décrit l'erreur rencontrée lors de l'action demandée au Redmine;
* **[CHAMP]:** décrit le champ qui a été traité;
* **[TYPES CHAMPS]:** JSON de l'ensemble des champs traités et des informations associées;
* **[FORMULAIRE] Envoyé:** informations du formulaire envoyé;
* **[ID GÉNÉRÉ]:** identifiant du projet Redmine généré;
* **[WIKI]:** indique quelle page wiki de quel projet est chargée, puis indique le HTML produit.

# Remerciements

Je remercie tous ceux dont leurs réponses sur les différents sites (comme Stackoverflow) ont pu m'aider:
* [Ehsan](https://stackoverflow.com/users/1002584/ehsan) pour sa méthode simple de conversion de format de date (oui, oui, j'avais besoin de ça!): https://stackoverflow.com/a/27087163/1098303
* [Dogbert](https://stackoverflow.com/users/320615/dogbert) pour sa technique des classes conditionnelles en Pug: https://stackoverflow.com/a/14144327/1098303

Également le mystérieux auteur de cet article là: http://www.finalclap.com/faq/257-javascript-supprimer-remplacer-accent

Et bien entendu ceux qui ont développé les technologies que j'utilise:
* [Redmine](http://www.redmine.org/): je suis vraiment un fan ultime de Redmine... Je n'utilise que ça, et pas que pour le développement. Merci Jean-Philippe!
* [NodeJS](https://nodejs.org): je crois que je ne toucherai plus une ligne de PHP. Ah si, pardon, pour les traduire en Node;
* [Bootstrap](http://getbootstrap.com/): quand on a un handicap certain comme moi pour tout ce qui est graphisme et CSS, c'est quand même bien pratique;
* [node-redmine](https://www.npmjs.com/package/node-redmine): ça m'a évité de perdre un temps fou pour utiliser les API de Redmine sous Node;
* [express](http://expressjs.com/): framework web très répandu;
* [pug](https://pugjs.org): après avoir essayé plusieurs moteurs de canevas, je crois que je me suis converti à celui-ci;
* [textile-js](https://www.npmjs.com/package/textile-js): ceci m'a permis d'économiser un temps certain pour ne pas avoir à développer une conversion textile en HTML;
* [colors](https://www.npmjs.com/package/colors): permet de faire de jolis messages dans les journaux;
* [body-parser](https://www.npmjs.com/package/body-parser): incontournable quand on utilise des formulaires, je pense;
* [config](https://www.npmjs.com/package/config): merci pour faciliter la tâche de configuration des applis...
* [dataTables](https://datatables.net/): on ne présente plus cette librairie qui permet de gérer les tableaux de manière remarquable;
* [jspdf](https://parall.ax/products/jspdf): permet d'enregistrer un PDF à partir d'une page, mais il faut lui préférer printJS pour des cas trop compliqués...
* [printJS](http://printjs.crabbly.com/): simplifie grandement la tâche d'impression, mais attention à bien imprimer dans un fichier pour ne pas gaspiller des feuilles et rester écoresponsable!
* [canvasJS](https://canvasjs.com/): permet de faire de jolis graphiques.

[menu]: ../../docs/images/menu.png "Icônes du menu"
[icone_accueil]: ../../docs/images/icone_accueil.png "Icône de l'accueil"
[icone_recapitulatif]: ../../docs/images/icone_recapitulatif.png "Icône du récapitulatif des projets"
[icone_statistiques]: ../../docs/images/icone_statistiques.png "Icône des statistiques"
[icone_wiki]: ../../docs/images/icone_wiki.png "Icône du wiki des projets"
[icone_pageProjet]: ../../docs/images/icone_pageProjet.png "Icône des pages projet"
[icone_creerProjet]: ../../docs/images/icone_creerProjet.png "Icône de la création d'un projet"
[creer_projet]: ../../docs/images/creer_projet.png "Capture d'écran du formulaire de création de projet"
[creer_projet_rempli]: ../../docs/images/creer_projet_rempli.png "Formulaire de création de projet rempli"
[creer_projet_succes]: ../../docs/images/creer_projet_succes.png "Message affiché lors du succès de la création d'un projet"
[wiki_projet]: ../../docs/images/wiki_projet.png "Page wiki d'un projet"
[resume_projet]: ../../docs/images/resume_projet.png "Page du résumé d'un projet"
[wiki_projet_manquant]: ../../docs/images/wiki_projet_manquant.png "Page wiki d'un projet introuvée"
[statistiques_projets]: ../../docs/images/statistiques_projets.png "Statistiques des projets"
[statistiques_projets_resultats]: ../../docs/images/statistiques_projets_resultats.png "Liste des projets concernés par la statistique"
[recapitulatif_projets]: ../../docs/images/recapitulatif_projets.png "Récapitulatif des projets"
[champ_eligible_redmine]: ../../docs/images/champ_eligible_redmine.png "Champ éligible dans Redmine"
